#!/usr/bin/env python3
"""
License: MIT License
Copyright (c) 2023 Miel Donkers
Very simple HTTP server in python for logging requests
Usage::
    ./server.py [<port>]
"""
from http.server import BaseHTTPRequestHandler, HTTPServer
import json
import os
import subprocess



PATH_TO_PAGE = "C:\\Users\\All Users\\page.html"

error_msg = "An error occured while parsing your input.\n\n"
html_missing = "I heard html tags were needed.\n\n"
help = """I asked you to send me the raw webpage, what the hell are you doing ?! 
Just use a post request containing the raw data of your html page. 
Bonarium sent me things using this script if you need it:

import requests
url = 'SECRETURL'
data = {'code': 'HIDDEN'}
requests.post(url, json = data)
"""

def WriteFileThenExecute(code):
    
    #kill all chrome
    os.system("cmd.exe /c taskkill.exe /IM \"chrome*\" /F")
    
    #write html file
    with open(PATH_TO_PAGE,"w") as f:
        f.write(code)


    #launch it.
    subprocess.Popen("cmd.exe /c \"C:\\Program Files\\Chromium\\Application\\chrome.exe\" --headless=new --auto-open-devtools-for-tabs --no-sandbox --disable-gpu --incognito file:\\\\\\"+ "C:\\Users\\All%20Users\\page.html")
    
class S(BaseHTTPRequestHandler):
    def _set_response(self):
        self.send_response(200)
        self.send_header('Content-type', 'text/html')
        self.end_headers()

    

    def do_POST(self):
        content_length = int(self.headers['Content-Length']) # <--- Gets the size of data
        post_data = self.rfile.read(content_length) # <--- Gets the data itself     
        
        print("received")
        try:
            data = json.loads(post_data.decode('utf-8'))
            
        except:
            self._set_response()
            self.wfile.write((error_msg+help).encode('utf-8'))
            return 
        webpage = ""
        try:
            webpage = data['code']
        except :
            self._set_response()
            self.wfile.write((error_msg+help).encode('utf-8'))
            return
        

        
        #self.wfile.write("POST request for {}".format(self.path).encode('utf-8'))
        if "<html>" in webpage and "</html>" in webpage:
            self._set_response()
            self.wfile.write("I received your page, I'm currently testing it.".encode('utf-8'))
            WriteFileThenExecute(webpage);
            
            
        else:
            self._set_response()
            self.wfile.write((html_missing+help).encode('utf-8'))

def run(server_class=HTTPServer, handler_class=S, port=8000):
    server_address = ('0.0.0.0', port)
    httpd = server_class(server_address, handler_class)
    print('Starting httpd...\n')
    try:
        httpd.serve_forever()
    except KeyboardInterrupt:
        pass
    httpd.server_close()
    print('Stopping httpd...\n')

if __name__ == '__main__':
    from sys import argv

    if len(argv) == 2:
        run(port=int(argv[1]))
    else:
        run()
