import sqlite3

con = sqlite3.connect("cache.db")
cur = con.cursor()
cur.execute("CREATE TABLE IF NOT EXISTS client_decrypts(ct, pt)")
cur.execute("CREATE UNIQUE INDEX IF NOT EXISTS client_ct ON client_decrypts(ct)")

cur.execute("CREATE TABLE IF NOT EXISTS server_decrypts(ct, pt)")
cur.execute("CREATE UNIQUE INDEX IF NOT EXISTS server_ct ON server_decrypts(ct)")

def get_cached_client_decrypt(ct):
    res = cur.execute("SELECT pt FROM client_decrypts WHERE ct=?", (ct,)).fetchone()
    if res:
        return res[0]

def set_cached_client_decrypt(ct, pt):
    cur.execute("INSERT OR IGNORE INTO client_decrypts VALUES (?, ?)", (ct, pt))
    con.commit()


def get_cached_server_decrypt(ct):
    res = cur.execute("SELECT pt FROM server_decrypts WHERE ct=?", (ct,)).fetchone()
    if res:
        return res[0]

def set_cached_server_decrypt(ct, pt):
    cur.execute("INSERT OR IGNORE INTO server_decrypts VALUES (?, ?)", (ct, pt))
    con.commit()
