import socket
import struct
from decrypt_client import xor, decrypt_block, encrypt, pad
from config import *

def make_message(mtype, payload):
    return bytes.fromhex(SESSION_ID) + struct.pack("<BH", mtype, len(payload)) + payload

def send_message(s, data):
    s.send(b"\x01" + encrypt(pad(data)))

def recv_message(s):
    mtype = s.recv(1)[0]
    return mtype, s.recv(1024)

def sendrecv(s, data):
    send_message(s, data)
    return recv_message(s)

s = socket.create_connection((SERVER_HOST, SERVER_PORT))

# try various messages (see writeup)
resp = sendrecv(s, make_message(7, b'{"username": "", "password": "", "activation key": ""}'))
print(resp)
