# Try and grab an activation key from the server
from decrypt_server import decrypt_server
from decrypt_client import fast_decrypt as decrypt_client, encrypt as encrypt_client, xor, pad, unpad
import struct
from config import *
import socket

def sendrecv(server, session_id, mtype, payload):
    msg = session_id + struct.pack("<BH", mtype, len(payload)) + payload
    server.send(b"\x01" + encrypt_client(pad(msg)))
    resp = server.recv(1024)
    if resp[0] == 0:
        raise Exception(resp[1:].decode())
    pt = unpad(decrypt_server(resp[1:]))
    return pt[:8], pt[8], pt[11:]

s = socket.create_connection((SERVER_HOST, SERVER_PORT))
session_id, mtype, payload = sendrecv(s, b"\x00" * 8, 1, b"Hello")
print(f"server response: session_id={session_id.hex()}, {mtype=}, {payload=}")
session_id, mtype, payload = sendrecv(s, session_id, 5, b"version")
print(f"server response: session_id={session_id.hex()}, {mtype=}, {payload=}")
# trinity
session_id, mtype, payload = sendrecv(s, session_id, 2, b"4a526da5f3e71981e937a96ff9b237b88e4adea4963e69d01be1e10e6acdad2d")
print(f"server response: session_id={session_id.hex()}, {mtype=}, {payload=}")
session_id, mtype, payload = sendrecv(s, session_id, 7, b'{"username": "", "password": "", "activation key": ""}')
print(f"server response: session_id={session_id.hex()}, {mtype=}, {payload=}")

"""
server response: session_id=22c593ec57b75814, mtype=1, payload=b'Hello'
server response: session_id=22c593ec57b75814, mtype=5, payload=b'1.3.37'
server response: session_id=22c593ec57b75814, mtype=2, payload=b'{"username": "trinity", "activated": true}'
server response: session_id=22c593ec57b75814, mtype=7, payload=b'{"username": "trinity", "password": "D0dg3Th1s", "activation key": "PR2YU5CZGCYMS272GLZ1WA43W7P44I7S"}'
"""
