from hsm_api import hsm_sign
import json

local = False

if local:
    filename = "collect-local.json"
    host = ("jammy", 5000)
else:
    filename = "collect-remote.json"
    host = ("localhost", 5555)

MSG = b"from:@mafiaTEST\\to:@mafiaBOSS\\content:foobar"

def sign(stepn, blockn):
    message, signature = hsm_sign(host,
        "mafiaTEST", "OnlyRequiredToSignAndSendMessages",
        "mafiaBOSS", "foobar", stepn, blockn)
    if message != MSG:
        raise Exception("didn't sign the right message - got %r" % message)

    return signature.hex()

result = {}
result["baseline"] = sign(1337, 1337)
for blockn in range(4):
    for stepn in range(0, 64, 2):
        key = "%02d_%02d" % (blockn, stepn)
        samples = []
        print(blockn, stepn)
        for i in range(16):
            samples.append(sign(stepn, blockn))
        result[key] = samples

with open(filename, "w") as outf:
    json.dump(result, outf)
